#include "lifo.h"
                    
/******************
 * IMPLEMENTATION *
 ******************/

/* CONSTRUCTORS */ 

LIFO NewLifo(CSIZE capacity)
{                                                 
  LIFO p;
  
  if (capacity < CSIZE_C(1)) 
    capacity = CSIZE_C(1);

  p = (LIFO) ALLOCMEM(sizeof(struct lifo_s) + capacity * sizeof(ITEM));
  if (p != NULL) {
    LIFO_ITEM(p) = (ITEM *) (p+1);
    LIFO_CAPA(p) = capacity;
    LifoReset(p);
  }
  return p;                                       
}

/* DESTRUCTORS */

void DelLifo(LIFO lifo)
{
  FREEMEM(lifo);
}

/* MODIFIERS */

void LifoReset(LIFO lifo)
{
  CHECK(IS_LIFO(lifo));

  LIFO_SIZE(lifo) = CSIZE_C(0);
  LIFO_TAIL(lifo) = CINDX_OUT;

  CHECK(LifoIsEmpty(lifo));
}

void LifoPutLast(LIFO lifo,ITEM item)
{
  CHECK(! LifoIsFull(lifo));

  LIFO_SIZE(lifo)++;
  LIFO_TAIL(lifo)++;
  LIFO_ITEM(lifo)[LIFO_TAIL(lifo)] = item;
}

ITEM LifoRemLast(LIFO lifo)
{
  ITEM item;

  CHECK(! LifoIsEmpty(lifo));

  item = LIFO_ITEM(lifo)[LIFO_TAIL(lifo)];
  LIFO_TAIL(lifo)--;
  LIFO_SIZE(lifo)--;
  return item;
}
