#include "platform.h"

size_t StrCpyN(char *dest,char *src,size_t n)
{
  size_t i;
  /* Copy into 'dest' as many non-'\0' characters of 'src' as possible,
     in the limit of 'n'. */
  for (i = 0; (src[i] != '\0') &&  (i < n); i++)
    dest[i] = src[i];
  /* Terminate 'dest' with a '\0'. */
  dest[i] = '\0'; 
  /* Return the number of non-'\0' characters copied. */
  return i;
}

size_t StrCatN(char *dest,char *src,size_t n)
{
  size_t i,j;
  /* Find the terminating '\0' in 'dest'. */
  for (i = 0; (dest[i] != '\0') && (i < n); i++) ;
  /* Append at the end of 'dest' as many non-'\0' characters of 'src' 
     as possible, in the limit of 'n'. */
  for (j = 0; (src[j] != '\0') && (i < n); j++, i++)
    dest[i] = src[j];
  /* Terminate 'dest' with a '\0'. */
  dest[i] = '\0'; 
  /* Return the number of non-'\0' characters appended. */
  return j; 
}

size_t StrFmtPath(char *path)
{
  size_t i;
  char *result;

  result = path; i = 0;
  while ((*path) != '\0')
    {
      (*result) = (*path);
      result++; i++;
      if ((*path) != '/')
	path++;
      else {
	do { path++; } while ((*path) == '/');
      }
    }
  (*result) = '\0';
  return i;
}
