#ifndef __CHECKER_H
#define __CHECKER_H

#include "engine.h"

/* CHECKER ENGINE */

implem void CheckStart(void);
implem void CheckSelect(void);
implem void CheckExpand(void);
implem void CheckExpandSucc(void);
implem void CheckExpandFail(void); 
implem void CheckPremissSucc(void);
implem void CheckPremissFail(void);
implem void CheckSuccess(void);
implem void CheckFailure(void);

/* CHECKER RESULTS */

implem ubint_t check_depth;

#define CheckDepth() VALUE(check_depth) 
/* Return: the number of rules applied in the longest branch of 
           the proof-search */

implem ubint_t check_nbapp;

#define CheckSize() VALUE(check_nbapp)
/* Return: the number of rules applied during the proof-search */

implem ubint_t check_pmem;

#define CheckPMem() VALUE(check_pmem)
/* Return: the number of proof-nodes needed to perform a proof-construction */

implem ubint_t check_kmem;

#define CheckKMem() VALUE(check_kmem)
/* Return: the number of kripke-nodes needed to perform a cm-construction */

implem ubint_t check_fbase;

#define CheckFBase() VALUE(check_fbase)
/* Return: the basic ideal cost of the forest operations, i.e., the number
   of forest nodes to which a rule has been applied or reversed during the 
   last check. */

implem ubint_t check_fovhd;

#define CheckFOvhd() VALUE(check_fovhd)
/* Return: the overhead cost of the forest operations, i.e., the number of
   forest nodes which were additionaly visited or updated while applying
   or reversing rule during the last check. */

#define CheckFCost() (CheckFBase() + CheckFOvhd())
/* Return: the total cost of the check (method + forest) */

implem ubint_t check_mbase;

#define CheckMBase() VALUE(check_mbase)
/* Return: */

implem ubint_t check_movhd;

#define CheckMOvhd() VALUE(check_movhd)
/* Return: */

#define CheckMCost() (CheckMBase() + CheckMOvhd())
/* Return: */

#define CheckCost() (CheckFCost() + CheckMCost())
/* Return: */

#define PercFOvhd() ((CheckFCost()>0) ? (CheckFOvhd()*100.0/CheckFCost()):0.0)
#define PercMOvhd() ((CheckMCost()>0) ? (CheckMOvhd()*100.0/CheckMCost()):0.0)
#define PercFCost() ((CheckCost()>0) ? (CheckFCost()*100.0/CheckCost()):0.0)
#define PercMCost() ((CheckCost()>0) ? (CheckMCost()*100.0/CheckCost()):0.0)
#define PercFBase() (100.0 - PercFOvhd())
#define PercMBase() (100.0 - PercMOvhd())

#endif
