%{
#include <stdio.h>
#include <string.h>
#include "strip.h"
#include "parser.h"
%}
%option noyywrap
%x FILENAME

space		[ \t]
nl		\n
num             [0-9]+
filerdx         [_A-Za-z0-9]+
fileext         [.]{filerdx}
filename        {filerdx}{fileext}?
varsimple	[A-Za-z][A-Za-z0-9]*
varslist        ({varsimple}\,)*{varsimple}
varsuffix       \({varslist}\)
varname         {varsimple}|{varsimple}{varsuffix}?

%%
"%".*$            
<*>{space}+       
"\\"{nl}              
<*>{nl}           {     BEGIN(INITIAL); return T_EOL;     }
<*>";"  	  {	BEGIN(INITIAL); return T_NOP;     }
"help"            {     return T_HELP;    }
"quit"		  {	return T_QUIT;	  }
"define"	  {	return T_DEFINE;  }
"sequent"	  {	return T_SEQUENT; }
"check"           {     return T_CHECK;   }
"solve"           {     return T_SOLVE;   }
"prove"           {     return T_PROVE;   }
"refute"          {     return T_REFUTE;  }
"stat"            {     return T_STAT;    }
"print"		  {	return T_PRINT;	  }
"verbose"         {     return T_VERBOSE; }
"proof"           {     return T_PROOF;   }
"kripke"          {     return T_KRIPKE;  }
"mp"              {     return T_MP;      }
"tex"             {     return T_TEX;     }
"xml"             {     return T_XML;     }
"gdl"             {     return T_GDL;     }
"set"             {     return T_SET;     }
"implem"          {     return T_IMPLEM;  }
"lrm"             {     return T_LRM;     }
"isc"             {     return T_ISC;     }
"method"          {     return T_METHOD;  }
"fleaf"           {     return T_FLEAF;   }
"rprec"           {     return T_RPREC;   }
"trace"		  {	return T_TRACE;	  }
"normal"          {     return T_NORMAL;  }
"prompt"          {     return T_PROMPT;  }
"iter"            {     return T_ITER;    }

"F"	          {	return T_BOT;	  }
"T"	          {	return T_TOP;	  } 
{varname}	  {	yylval.nom = yytext; 
                        return T_VARNAME; 
                  }
"~"	          {	return T_NOT;	  }
"#"	          {	return T_NOT;	  }
"&"		  {	return T_AND;	  }
"|"		  {	return T_OR;	  }
"->"		  {	return T_IMP;	  }
"<->"		  {	return T_EQV;	  }
"("		  {	return T_LPAR;	  }
")"		  {	return T_RPAR;	  }
","		  {	return T_COMMA;	  } 
"=>"	          {	return T_TSTILE;  }
"|-"	          {	return T_TSTILE;  }
"="               {     return T_EQU;     }
">"               {     BEGIN(FILENAME); return T_OUTW;    }
">>"              {     BEGIN(FILENAME); return T_OUTA;    }
{num}             {     yylval.num = atoi(yytext); 
                        return T_NUMBER; 
                  }
<FILENAME>{filename}  {  yylval.nom = yytext;
                         BEGIN(INITIAL);
                         return T_FILE;
                      }

%%













