#include "listform.h"

/******************
 * IMPLEMENTATION *
 ******************/

/* CONSTRUCTORS - DESTRUCTORS */

LFORM ConsLForm(LFORM l,PFORM p)
{
  LFORM new;

  new = (LFORM) malloc(sizeof(struct lform_s));
  if (new == NULL)
    FatalError("ConsLForm","Cannot extend formula list");
  else {
    LF_FORM(new) = p;
    LF_TAIL(new) = l;
  }
  return new;
}

void DelLForm(LFORM l,BOOL freealsoform)
{       
  LFORM p;
  
  while (! LFormIsEmpty(l))
    {
      if (freealsoform)
	/* Deletes formula inside link "l" */
	DelForm(LF_FORM(l));
      /* Keep in mind that we must free "l" */
      p = l;
      /* Move to the rest of list "l" */
      l = LF_TAIL(l);
      /* Free link "p" */
      free ((void *) p);
    }
}

/* ACCESSORS */

BOOL LFormHasPtr(LFORM l,PFORM p)
{
  while (! LFormIsEmpty(l))
    {
      if (LF_FORM(l) == p)
	return TRUE;
      l = LF_TAIL(l);
    }
  return FALSE;
}

BOOL LFormHasSame(LFORM l,PFORM p)
{
  while (! LFormIsEmpty(l))
    {
      if (FormIsEqu(LF_FORM(l),p))
	return TRUE;
      l = LF_TAIL(l);
    }
  return FALSE;
}

CSIZE LFormSize(LFORM l)
{	
  CSIZE n;
  
  n = CSIZE_C(0);
  while (! LFormIsEmpty(l))
    {	
      l = LF_TAIL(l);
      n++;
    }
  return n;
}

/* MODIFIERS */

BOOL MapLForm(LFORM l,TMAPLFORM mapfunc)
{
  while (! LFormIsEmpty(l)) 
    {
      if (! mapfunc(LF_FORM(l)))
	return FALSE; 
      l = LF_TAIL(l);
    }
  return TRUE;
}

LFORM DupLForm(LFORM l,BOOL dupalsoform)
{
 LFORM l2;

 l2 = LFORM_EMPTY;
 while (! LFormIsEmpty(l))
   {
     if (dupalsoform)
       l2 = ConsLForm(l2,DupForm(LF_FORM(l)));
     else
       l2 = ConsLForm(l2,LF_FORM(l));
     l = LF_TAIL(l);
   }
 return l2;
}

CINDX IndexLForm(LFORM l,CINDX start)
{
  while (! LFormIsEmpty(l))
    {
      start = IndexLeftForm(LF_FORM(l),start);
      l = LF_TAIL(l);
    }
  return start;
}

/* DISPLAY */

void PrintLForm(LFORM l,void (*pfunc)(PFORM))
{
  if (! LFormIsEmpty(l)) {
    pfunc(LF_FORM(l));
    l = LF_TAIL(l);
    while (! LFormIsEmpty(l))
      {
	printf(",");
	pfunc(LF_FORM(l));
	l = LF_TAIL(l);
      }
  }
}


  
  





