#ifndef __PROOF_H
#define __PROOF_H

#include "rules.h"
#include "forest.h"

/************************
 * TYPES AND STRUCTURES *
 ************************/

typedef struct pnode_s PNODE, *PTREE;
struct pnode_s
{
  FINDX index;
  PTREE son[2];
  PTREE father;
};

/* Clean access to the fields of the structure */

#define PT_FINDX(p) ((p)->index)  /* The index to which the rule applies */
#define PT_SON1(p)  ((p)->son[0]) /* The first premiss */
#define PT_SON2(p)  ((p)->son[1]) /* The second premiss */
#define PT_FATH(p)  ((p)->father) /* The father of the node */

typedef CSIZE PSIZE;
#define PSIZE_MIN  CSIZE_MIN
#define PSIZE_MAX  CSIZE_MAX
#define PSIZE_C(c) CSIZE_C(c)

/*************
 * INTERFACE *
 *************/

/* CONSTRUCTORS - DESTRUCTORS */

public PNODE *AllocPSpace(PSIZE capacity);

public void FreePSpace(void);

/* ACCESSORS */

#define PTREE_EMPTY NULL

#define PTreeIsEmpty(tree) ((tree) == PTREE_EMPTY)

public PSIZE PTreeSize(PTREE tree);

public PSIZE PTreeDepth(PTREE tree);

/* MODIFIERS */

public PTREE NewPTree(FINDX fnidx);

public PTREE AddPTree(PTREE father,PTREE son,PREM prem);

public PTREE DelPTree(PTREE tree);

#endif
