#ifndef __PROVER_H
#define __PROVER_H

#include "checker.h" /* need the checking features */

/* PROVER ENGINE */

implem void ProveStart(void);
#define ProveSelect CheckSelect
#define ProveExpand CheckExpand
implem void ProveExpandSucc(void);
implem void ProveExpandFail(void);
implem void ProvePremissSucc(void);
implem void ProvePremissFail(void);
implem void ProveSuccess(void);
implem void ProveFailure(void);

/* PROVER RESULTS */

implem PTREE proof_tree;

#define ProofTree() VALUE(proof_tree)
/* Return a pointer to the root of the current proof-tree
   Return
     PTREE_EMPTY: if there is no current proof-tree built
     Current proof-tree: otherwise */

/* CAUTION: The following operations are only defined (and relevant) when 
   there is a proof-tree available, i.e, when the function ProofTree() 
   does not return PTREE_EMPTY. */

implem typmet_t proof_typmet;

#define ProofMethod() GUARD(ProofTree() != PTREE_EMPTY,proof_typmet)
/* Return: the number of the method used to build the current proof-tree.
   Require: ProofTree() != PTREE_EMPTY */

implem ubint_t  proof_size;

#define ProofSize() GUARD(ProofTree() != PTREE_EMPTY,proof_size)
/* Return: the number of nodes in the current proof-tree.
   Require: ProofTree() != PTREE_EMPTY */

implem ubint_t  proof_depth;

#define ProofDepth() GUARD(ProofTree() != PTREE_EMPTY,proof_depth)
/* Return: the depth of the current proof-tree
   Require: ProofTree() != PTREE_EMPTY */

#endif
