#ifndef __REFUTER_H
#define __REFUTER_H

#include "checker.h" /* need the checking features */

/* REFUTER ENGINE */

implem void RefuteStart(void);
#define RefuteSelect CheckSelect
#define RefuteExpand CheckExpand
implem void RefuteExpandSucc(void);
implem void RefuteExpandFail(void);
implem void RefutePremissSucc(void);
implem void RefutePremissFail(void);
implem void RefuteSuccess(void);
implem void RefuteFailure(void);

/* REFUTER RESULTS */

implem KTREE kripke_tree;

#define KripkeTree() VALUE(kripke_tree)
/* Return a pointer to the root of the current kripke-tree.
   Return
     KTREE_EMPTY: if there is no current kripke-tree built
     KTREE pointer to the root of the current kripke-tree: otherwise */

/* CAUTION: The following operations are only defined (and relevant) when 
   there is a kripke-tree available, i.e, when the function KripkeTree() 
   does not return KTREE_EMPTY */

implem typmet_t kripke_typmet;

#define KripkeMethod() GUARD(KripkeTree() != KTREE_EMPTY,kripke_typmet)
/* Return: the number of the method used to build the current kripke-tree.
   Require: KripkeTree() != KTREE_EMPTY */

implem ubint_t  kripke_size;

#define KripkeSize() GUARD(KripkeTree() != KTREE_EMPTY,kripke_size)
/* Return the number of nodes in the current kripke-tree.
   Require: KripkeTree() != KTREE_EMPTY */

implem ubint_t  kripke_depth;

#define KripkeDepth() GUARD(KripkeTree() != KTREE_EMPTY,kripke_depth)
/* Return: the number of nodes of the longest branch in the current kripke-tree
   Require: KripkeTree() != KTREE_EMPTY */


#endif
