#include "tracer.h"

/******************
 * IMPLEMENTATION *
 ******************/

/* TRACING FUNCTIONS */

extern BOOL abort_search;

void TraceLine(FSIZE lvl,ubint_t fid,ubint_t sid,
	       char *act,FINDX idx,char *ru)
{
  printf("%03" PRIuBI ":%05" PRIuBI ":%05" PRIuBI ": %s %3" PRIuBI " %-5s  ",
	 lvl,fid,sid,act,idx,ru);
  PrintForest(TRUE);
  if ((! IsTTY()) || (TraceMode() != TYPTRC_PROMPT))
    /* We are not on a terminal or not in step-by-step mode */ 
    printf("\n");
  else {
    /* We wait for a keyboard input to continue */
    if (getchar() == 'q') abort_search = TRUE;
  }
}

char *FormatRuleName(RULE rule,PREM prem)
{
  static char buffer[6];
  static unsigned int i;
  static char *source;

  REQUIRE(IS_RULE(rule) && IS_PREM(prem));

  i = 0;
  source = RuleName(rule);
  while (source[i] && (i < 4))
    {
      buffer[i] = source[i];
      i++;
    }

  if (! RuleIsSing(rule)) {
    buffer[i] = (prem == PREM_FST) ? '1':'2';
    i++;
  }

  buffer[i] = 0;
  return buffer;
}

void TraceStart(void)
{
  CheckStart();
  printf("trace method = %s\n",MethodName(search_typmet));
}

void TraceExpand(void)
{
  CheckExpand();
  TraceLine(PsSize(),TopSit(),PsSit() + UBINT_C(1),"e",
	    select_fnidx,FormatRuleName(select_rule,select_prem));
}

void TraceExpandSucc(void) 
{   
  CheckExpandSucc();
  TraceLine(PsSize(),TopSit(),UBINT_C(0),"-",N_ORIGIN,"axiom");
}

void TraceExpandFail(void) 
{ 
  CheckExpandFail();
  TraceLine(PsSize(),TopSit(),UBINT_C(0),"-",N_ORIGIN,"nonax");
}

void TracePremissSucc(void)
{
  CheckPremissSucc();
  /*  TraceLine(PsSize(),TopSit(),RevSit(),"s",
      RevIdx(),FormatRuleName(RevRule(),RevPrem())); */
}

void TracePremissFail(void)
{
  CheckPremissFail();
  /*  TraceLine(PsSize(),TopSit(),RevSit(),"f",
      RevIdx(),FormatRuleName(RevRule(),RevPrem())); */
}

