#ifndef __TRACER_H
#define __TRACER_H

#include "checker.h"

/* TRACER ENGINE */

implem void TraceStart(void);
#define TraceSelect CheckSelect
implem void TraceExpand(void);
implem void TraceExpandSucc(void);
implem void TraceExpandFail(void);
implem void TracePremissSucc(void);
implem void TracePremissFail(void);
#define TraceSuccess CheckSuccess
#define TraceFailure CheckFailure

/* TRACE MODES */

typedef enum { TYPTRC_NORMAL, TYPTRC_PROMPT } typtrc_t;
#define IS_TYPTRC(t) ((t) <= TYPTRC_PROMPT)

implem typtrc_t use_typtrc; 

#define TraceMode() VALUE(use_typtrc)
/* Return: the current value of the trace mode */

implem char *typtrc_t_str[];

#define TraceModeStr() GETSAFE(IS_TYPTRC(TraceMode()),\
			       typtrc_t_str[TraceMode()])
/* Return: the name of the current trace mode in clear */

#define SetTraceMode(mode) (use_typtrc = (mode))
/* Define 'mode' as the current trace mode value */


#endif
